org.apache.hc.core5.http.nio.support

## Class AbstractAsyncRequesterConsumer<T,E>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.AbstractAsyncRequesterConsumer<T,E>

- Type Parameters:
    `T` - request processing result representation.
    `E` - request entity representation.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncRequestConsumer<T>, ResourceHolder

      public abstract class AbstractAsyncRequesterConsumer<T,E>
      extends Object
      implements AsyncRequestConsumer<T>

  Abstract asynchronous request consumer that makes use of `AsyncEntityConsumer` to process request message content.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractAsyncRequesterConsumer(AsyncEntityConsumer<E> dataConsumer)`
    `AbstractAsyncRequesterConsumer(Supplier<AsyncEntityConsumer<E>> dataConsumerSupplier)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract T` | `buildResult(HttpRequest request, E entity, ContentType contentType)` Triggered to generate object that represents a result of request message processing.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeRequest(HttpRequest request, EntityDetails entityDetails, HttpContext httpContext, FutureCallback<T> resultCallback)` Triggered to signal receipt of a request message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractAsyncRequesterConsumer

          public AbstractAsyncRequesterConsumer(Supplier<AsyncEntityConsumer<E>> dataConsumerSupplier)

    - #### AbstractAsyncRequesterConsumer

          public AbstractAsyncRequesterConsumer(AsyncEntityConsumer<E> dataConsumer)

  - ### Method Detail

    - #### buildResult

          protected abstract T buildResult(HttpRequest request,
                                           E entity,
                                           ContentType contentType)

      Triggered to generate object that represents a result of request message processing.
      Parameters:
        `request` - the request message.
        `entity` - the request entity.
        `contentType` - the request content type.
      Returns:
        the result of request processing.

    - #### consumeRequest

          public final void consumeRequest(HttpRequest request,
                                           EntityDetails entityDetails,
                                           HttpContext httpContext,
                                           FutureCallback<T> resultCallback)
                                    throws HttpException,
                                           IOException

      Description copied from interface: `AsyncRequestConsumer`
      Triggered to signal receipt of a request message head.
      Specified by:
        `consumeRequest` in interface `AsyncRequestConsumer<T>`
      Parameters:
        `request` - the request message head.
        `entityDetails` - the request entity details or `null` if the request does not enclose an entity.
        `httpContext` - the actual execution context.
        `resultCallback` - the result callback called when request processing has been completed successfully or unsuccessfully.
      Throws:
        `HttpException`
        `IOException`

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException`

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException`

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException`
        `IOException`

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncRequestConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncRequestConsumer<T>`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public final void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2022 The Apache Software Foundation. All rights reserved.